gccsite/gcc/urls.py
# Copyright (C) <2018> Association Prologin <association@prologin.org>
# SPDX-License-Identifier: GPL-3.0+

from django.contrib import admin
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse
from django.urls import include, path

from gcc import staff_views, views

app_name = 'gcc'


def crash_test(request):
    if request.user.is_authenticated:
        1 / 0
    return HttpResponse(status=204)


NEWSLETTER_PATTERNS = [
    path(
        'unsubscribe/<str:email>/<str:token>/',
        views.NewsletterUnsubscribeView.as_view(),
        name='news_unsubscribe',
    )
]

APPLICATION_PATTERNS = [
    path(
        'review/',
        staff_views.ApplicationReviewIndexView.as_view(),
        name='application_review_index',
    ),
    path(
        'review/<int:edition>/<int:event>/',
        staff_views.ApplicationReviewView.as_view(),
        name='application_review',
    ),
    path(
        'validation/<int:pk>/<int:edition>/',
        views.ApplicationValidationView.as_view(),
        name='application_validation',
    ),
    path(
        'form/<int:edition>/',
        login_required(
            views.ApplicationFormView.as_view(),
            login_url='https://prologin.org/user/login',
        ),
        name='application_form',
    ),
    path(
        'wishes/<int:edition>/',
        views.ApplicationWishesView.as_view(),
        name='application_wishes',
    ),
    path(
        'summary/<int:pk>/',
        views.ApplicationSummaryView.as_view(),
        name='application_summary',
    ),
    path(
        'confirm/<int:wish>/',
        views.ApplicationConfirmVenueView.as_view(),
        name='confirm',
    ),
    path(
        'label_remove/<int:event>/<int:applicant>/<int:label>/',
        staff_views.ApplicationRemoveLabelView.as_view(),
        name='delete_applicant_label',
    ),
    path(
        'label_add/<int:event>/<int:applicant>/<int:label>/',
        staff_views.ApplicationAddLabelView.as_view(),
        name='add_applicant_label',
    ),
    path(
        'update_wish/<int:wish>/<int:status>/',
        staff_views.UpdateWish.as_view(),
        name='update_wish',
    ),
    path(
        'accept_all/<int:event>/',
        staff_views.ApplicationAcceptView.as_view(),
        name='accept_all',
    ),
    path(
        'accept_all_send/<int:event>/',
        staff_views.ApplicationAcceptSendView.as_view(),
        name='accept_all_send',
    ),
]

urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('crashtest/', crash_test),
    path('application/', include(APPLICATION_PATTERNS)),
    path('newsletter/', include(NEWSLETTER_PATTERNS)),
    path('learn/', views.LearnMoreView.as_view(), name='learn_more'),
    path('resources/', views.RessourcesView.as_view(), name='resources'),
    path('contact/', views.ContactView.as_view(), name='contact'),
    path('privacy/', views.PrivacyView.as_view(), name='privacy'),
    path('editions/', views.EditionsView.as_view(), name='editions'),
    path(
        'editions/<int:year>/', views.EditionsView.as_view(), name='editions'
    ),
    path('tutorials/', views.TutorialsView.as_view(), name='tutorials'),
    # Remove after february 2020: candidates received a wrong url
    path(
        'confirm/<int:wish>/',
        views.ApplicationConfirmVenueView.as_view(),
        name='confirm',
    ),
    # Admin panel
    path('admin/', admin.site.urls),
]

gccsite/gcc/views.py
# Copyright (C) <2019> Association Prologin <association@prologin.org>
# SPDX-License-Identifier: GPL-3.0+

import random
from datetime import datetime

from django.conf import settings
from django.contrib import auth, messages
from django.http import Http404, HttpResponseRedirect
from django.shortcuts import get_object_or_404
from django.urls import reverse, reverse_lazy
from django.utils import timezone
from django.utils.text import format_lazy
from django.utils.translation import ugettext_lazy as _
from django.views.generic import RedirectView, TemplateView
from django.views.generic.detail import DetailView
from django.views.generic.edit import FormView
from django.template.loader import get_template
from django.core.mail import send_mail

from gcc.forms import (
    ApplicationWishesForm,
    CombinedApplicantUserForm,
    EmailForm,
)
from gcc.models import (
    Applicant,
    ApplicantStatusTypes,
    Edition,
    Event,
    EventWish,
    Sponsor,
    SubscriberEmail,
)
from prologin.email import send_email
from rules.contrib.views import PermissionRequiredMixin
from zinnia.models import Entry

# Editions


class EditionsView(TemplateView):
    template_name = "gcc/editions.html"


class TutorialsView(TemplateView):
    template_name = "gcc/tutorials.html"


# Privacy


class PrivacyView(TemplateView):
    template_name = "gcc/privacy.html"


# Homepage


class IndexView(FormView):
    template_name = "gcc/index.html"
    form_class = EmailForm
    success_url = reverse_lazy("gcc:index")

    def form_valid(self, form):
        instance, created = SubscriberEmail.objects.get_or_create(
            email=form.cleaned_data['email']
        )

        if created:
            messages.add_message(
                self.request, messages.SUCCESS, _('Subscription succeeded')
            )
            send_email(
                'gcc/mails/subscribe',
                instance.email,
                {'unsubscribe_url': instance.get_unsubscribe_url},
            )
        else:
            messages.add_message(
                self.request,
                messages.WARNING,
                _('Subscription failed: already subscribed'),
            )

        return super().form_valid(form)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        articles = Entry.published.prefetch_related('authors').all()[
            : settings.HOMEPAGE_ARTICLES
        ]
        context.update(
            {
                'last_edition': Edition.objects.latest(),
                'sponsors': list(Sponsor.objects.active()),
                'articles': articles,
            }
        )
        context['events'] = Event.objects.filter(
            signup_start__lt=timezone.now(),
            signup_end__gt=timezone.now(),
            edition=context['last_edition'],
        ).order_by('event_start')
        random.shuffle(context['sponsors'])
        return context


# Ressources, Contact, Learn More


class RessourcesView(TemplateView):
    template_name = "gcc/resources.html"


class ContactView(TemplateView):
    template_name = "gcc/contact.html"


class LearnMoreView(FormView):
    template_name = "gcc/learn_more.html"
    form_class = EmailForm
    success_url = reverse_lazy("gcc:learn_more")

    def form_valid(self, form):
        instance, created = SubscriberEmail.objects.get_or_create(
            email=form.cleaned_data['email']
        )

        if created:
            messages.add_message(
                self.request, messages.SUCCESS, _('Subscription succeeded')
            )
            send_email(
                'gcc/mails/subscribe',
                instance.email,
                {'unsubscribe_url': instance.get_unsubscribe_url},
            )
        else:
            messages.add_message(
                self.request,
                messages.WARNING,
                _('Subscription failed: already subscribed'),
            )

        return super().form_valid(form)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context.update(
            {
                'last_edition': Edition.objects.latest(),
                'SITE_HOST': settings.SITE_HOST,
            }
        )
        context['events'] = Event.objects.filter(
            signup_start__lt=timezone.now(),
            signup_end__gt=timezone.now(),
            edition=context['last_edition'],
        ).order_by('event_start')
        return context


# Newsletter


class NewsletterUnsubscribeView(RedirectView):
    def get_redirect_url(self, *args, **kwargs):
        return reverse('gcc:index')

    def get(self, request, *args, **kwargs):
        try:
            subscriber = SubscriberEmail.objects.get(email=kwargs['email'])

            if subscriber.unsubscribe_token == kwargs['token']:
                subscriber.delete()
                messages.add_message(
                    request,
                    messages.SUCCESS,
                    _('Successfully unsubscribed from newsletter.'),
                )
            else:
                messages.add_message(
                    request,
                    messages.ERROR,
                    _('Failed to unsubscribe: wrong token.'),
                )
        except SubscriberEmail.DoesNotExist:
            messages.add_message(
                request,
                messages.ERROR,
                _('Failed to unsubscribe: unregistered address'),
            )

        return super().get(request, *args, **kwargs)


# Application


class ApplicationSummaryView(PermissionRequiredMixin, DetailView):
    model = auth.get_user_model()
    context_object_name = 'shown_user'
    template_name = 'gcc/application/summary.html'
    permission_required = 'users.edit'
    success_url = reverse_lazy("gcc:summary")

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        shown_user = context[self.context_object_name]

        context.update(
            {
                'shown_user': shown_user,
                'current_edition': Edition.current(),
                'applicant': get_object_or_404(
                    Applicant, user=shown_user, edition=Edition.current()
                ),
                'has_applied_to_current': Edition.current().user_has_applied(
                    shown_user
                ),
            }
        )
        return context

    def get(self, request, *args, **kwargs):
        result = super().get(request, *args, **kwargs)
        if not self.object.is_active and not self.request.user.is_staff:
            raise Http404()
        return result


class ApplicationValidationView(PermissionRequiredMixin, DetailView):
    model = auth.get_user_model()
    context_object_name = 'shown_user'
    template_name = 'gcc/application/validation.html'
    permission_required = 'users.edit'

    def get(self, request, *args, **kwargs):
        result = super().get(request, *args, **kwargs)
        if not self.object.is_active and not self.request.user.is_staff:
            raise Http404()
        return result

    # TODO: remove redondancy of get
    def get_context_data(self, **kwargs):
        applicant = get_object_or_404(
            Applicant, user=self.request.user, edition=self.kwargs['edition']
        )
        context = super().get_context_data(**kwargs)
        context['applicant'] = applicant
        return context

    def get_success_url(self):
        return reverse(
            'gcc:application_summary', kwargs={'pk': self.request.user.pk}
        )

    def post(self, request, *args, **kwargs):
        super().get(request, *args, **kwargs)

        applicant = get_object_or_404(
            Applicant, user=self.request.user, edition=kwargs['edition']
        )

        if not applicant.has_complete_application():
            messages.add_message(
                request,
                messages.ERROR,
                _(
                    'Failed to validate your application, your '
                    'profile is incomplete.'
                ),
            )
        else:
            applicant.validate_current_wishes()
            messages.add_message(
                request,
                messages.SUCCESS,
                _(
                    'Successfully validated your application. '
                    'You should receive a confirmation email soon.'
                ),
            )
            send_mail(
                format_lazy(
                    "[Girls Can Code!][{}] {}",
                    Edition.current().year,
                    _("Application confirmation"),
                ),
                get_template('gcc/mails/application.body.text.html').render(
                    {'applicant': applicant}
                ),
                settings.DEFAULT_FROM_EMAIL,
                [self.request.user.email]
                # TODO Change this when settings.GCC_EDITION is up
            )

        if not self.object.is_active and not self.request.user.is_staff:
            raise Http404()

        return HttpResponseRedirect(
            reverse(
                'gcc:application_summary', kwargs={'pk': self.request.user.pk}
            )
        )


class ApplicationFormView(FormView):
    template_name = 'gcc/application/form.html'
    form_class = CombinedApplicantUserForm

    def dispatch(self, request, *args, **kwargs):
        # Redirect if already validated for this year.
        if request.user.is_anonymous:
            return super().dispatch(request, *args, **kwargs)

        edition = get_object_or_404(Edition, year=kwargs['edition'])
        applicant = Applicant.for_user_and_edition(self.request.user, edition)

        if applicant.is_locked():
            messages.add_message(
                request,
                messages.ERROR,
                _(
                    'Your application has already been validated, if you '

gccsite/gcc/templates/gcc/application/accept.html
{% extends "gcc/base.html" %}
{% load i18n %}

{% block title %}{% trans "Accept candidates" %}{% endblock %}

{% block content %}
  <div class="row">
    <div class="col-md-6">
      <h3>
        {% blocktrans with event=event.center nb_applicants=applicants|length count nb_applicants as nb_applicants %}
          Accept the candidate for {{event}}?
        {% plural %}
          Accept all the {{nb_applicants}} candidates for {{event}}?
        {% endblocktrans %}
      </h3>
      <p>
      {% blocktrans %}Make sure you <strong>already</strong> sent an email to
      all the candidates to notify that they are selected for the event, and
      asking them to confirm their venue.{% endblocktrans %}
      </p>
      <a class="btn btn-success" href="{% url 'gcc:accept_all_send' event=event.pk %}">
        {% trans "Go On" %}
      </a>
    </div>
    <div class="col-md-6">
      <h3>{% trans "Concerned candidates" %}</h3>
      <ul>
        {% for applicant in applicants %}
          <li>
            {{ applicant.user.first_name }} {{ applicant.user.last_name }}
            - {{ applicant.user.email }}
          </li>
        {% endfor %}
      </ul>
    </div>
  </div>
{% endblock %}

gccsite/gcc/templates/gcc/application/form.html
{% extends "gcc/base.html" %}
{% load bootstrap %}
{% load static %}
{% load i18n %}

{% block title %}{% trans "GCC! − Application" %}{% endblock %}

{% block content %}
<section class="wrapper">
<div class="container">
    {% if not applicant.has_complete_application %}
    <div class="alert alert-warning" role="alert">
        {% trans "You are missing some key information, you won't be able to validate your application !" %}
    </div>
    {% endif %}
    <h2>{% trans "Application Form" %}</h2>

    {% blocktrans %} The legal aspect of the form has to be filled in by the
    legal representative, however the informative part and the motivational
    questions have to be filled in by the participant! {% endblocktrans %}

    <form method="post" class="form-horizontal">
      {% csrf_token %}
      {{ form|bootstrap_horizontal:'col-sm-3' }}
      <section class="application_form">
          <p>{% trans "I consent to the processing of my data by Prologin."%}</p>
      </section>
      <input class="btn btn-lg btn-primary btn-block" type="submit" value="{%trans "Validate and select my wishes" %}">
    </form>
    <section class="application_form">
        <p>
          {% url 'gcc:privacy' as url_privacy %}
          {% blocktrans with url=url_privacy %} The GCC! summer camps are
          managed by the Prologin association, acting as Data Controller.
          Answers collected by this form allow us to prepare the summer camps:
          content customization, dietary constraints, etc.<br>
          To learn more about your data management and your rights, please
          <a href="{{url}}">see our dedicated page</a>. {% endblocktrans %}
        </p>
    </section>
    <section>
      {% blocktrans %} (*) This field will be required to validate your
      application. {% endblocktrans%}
    </section>
</div>
</section>
{% endblock %}

gccsite/gcc/templates/gcc/application/review_index.html
{% extends "gcc/base.html" %}
{% load i18n rules %}
{% block title %}{% trans "Review" %}{% endblock %}

{% block content %}

  {% regroup events by edition.year as grouped_events %}

  <h1>{% trans "Review index" %}</h1>

  <ul class="pager align-left">
    {% for group in grouped_events %}
      {% with year=group.grouper %}
        <li><a href="#year-{{ year }}">{{ year }}</a></li>
      {% endwith %}
    {% endfor %}
  </ul>

  <table class="table table-striped table-hover">
    <thead>
      <tr><th>{% trans "Event" %}</th><th>{% trans "Center" %}</th><th></th></tr>
    </thead>
    <tbody>
    {% for group in grouped_events %}
      {% with group.grouper as year %}
        <tr id="year-{{ year }}">
          <th colspan="3">{{ year }}</th>
        </tr>
      {% endwith %}
      {% for event in group.list|dictsort:'event_start' %}
        <tr>
            {% if event.is_long %}
            <td>{% trans 'Long Summer Camp' %}</td>
            {% else %}
            <td>{% trans 'Short Summer Camp' %}</td>
            {% endif %}
          <td>{{ event.center.name }} <span class="text-muted">{{ event.event_start|date:"SHORT_DATE_FORMAT" }}</span></td>
          <td>
            {% has_perm 'gcc.can_review_event' request.user event as can_review %}
            {% if can_review %}
            <a href="{% url 'gcc:application_review' edition=event.edition.year event=event.pk %}" class="btn btn-default btn-xs"><i class="fa fa-list-alt"></i> {% trans "Browse" %}</a>
            {% endif %}
          </td>
        </tr>
      {% endfor %}
    {% endfor %}
    </tbody>
  </table>

{% endblock %}

gccsite/gcc/templates/gcc/application/summary.html
{% extends "gcc/base.html" %}
{% load i18n static staticfiles %}
{% load application_status utils %}

{% block head %}
  <link rel="stylesheet" href="{% static 'vendor/bootstrap/dist/css/bootstrap.min.css' %}" />
{% endblock %}

{% block title %}{% trans "GCC! − Summary" %}{% endblock %}

{% block content %}
<div class="row">
    <div class="col-sm-4 col-md-3">
        <ul class="fa-ul text-break-word profile-info" style="margin-bottom: 1em">
            {% if shown_user.get_full_name %}
            <li title="{% trans " Full name" %}">
                <i class="fa fa-li fa-user"></i>
                <span class="text-capitalize">{{ shown_user.first_name }}</span>
                <span class="text-smallcaps">{{ shown_user.last_name }}</span>
            </li>
            {% endif %}
            {% if shown_user.phone %}
            <li title="{% trans " Phone number" %}">
                <i class="fa fa-li fa-phone"></i>
                <a href="tel:{{ shown_user.phone }}">{{ shown_user.phone|phone_number }}</a>
            </li>
            {% endif %}
            {% if shown_user.email %}
            <li title="{% trans " Email address" %}">
                <i class="fa fa-li fa-envelope-o"></i>
                <a href="email:{{ shown_user.email }}">{{ shown_user.email }}</a>
            </li>
            {% endif %}
            {% if shown_user.birthday %}
            <li title="{% trans " Birth day" %}"><i class="fa fa-li fa-birthday-cake"></i>
                {{ shown_user.birthday }}<br>
                <small class="text-muted">{{ shown_user.birthday|timesince }}</small>
            </li>
            {% endif %}
            {% if user.has_partial_address %}
            <li title="{% trans " Postal address" %}">
                <i class="fa fa-li fa-map-marker"></i>
                <address>
                    {{ shown_user.address|linebreaksbr }}<br>
                    {{ shown_user.postal_code }} {{ shown_user.city }}<br>
                    {{ shown_user.country }}
                </address>
            </li>
            {% endif %}
            <li title="{% trans " Date joined" %}">
                <i class="fa fa-li fa-clock-o"></i>
                {% trans "Member for" %} {{ shown_user.date_joined|timesince }}
            </li>
        </ul>
    </div>
    <div class="col-sm-8 col-md-8 compact-headings">
        {% if not has_applied_to_current %}
        <div class="panel panel-default">
            <div class="panel-heading">
                            <td width="100%">{% trans "Edition" %} {{current_edition}}</td>
            </div>
            <div class="panel-body">
                <table class="panel-title">
                    <tbody>
                        <tr>
                            <td width="100%">
                                <p> {% trans "Sadly you did not apply yet for the current edition..." %} </p>
                            </td>
                            <td class="text-right">
                                <a  href="{% url 'gcc:application_form' edition=current_edition %}"
                              class="btn btn-default btn-xs">
         <i class="fa fa-pencil"></i> {% trans "Apply" %}</a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        {% endif %}

        <div class="panel panel-default">
            <div class="panel-heading">
                <table class="panel-title">
                    <tbody>
                        <tr>
                            <td width="100%">Edition {{applicant.edition}}</td>
                            {% if applicant.edition.subscription_is_open %}
                              {% if applicant.status == 0 %}
                                <td class="text-right">
                                  <a  href="{% url 'gcc:application_form' edition=applicant.edition %}" class="btn btn-default btn-xs">
                                    <i class="fa fa-pencil"></i> {% trans "Edit application" %}
                                  </a>
                                </td>
                                {% if applicant.edition.subscription_is_open %}
                                  <td class="text-right">
                                    <a  href="{% url 'gcc:application_validation' pk=user.id edition=applicant.edition %}" class="btn btn-default btn-xs">
                                      <i class="fa fa-save"></i> {% trans "Validate application" %}
                                    </a>
                                  </td>
                                {% endif %}
                              {% else %}
                                <span class="badge {{ applicant.status|status_badge }} pull-right">
                                  {{ applicant.get_status_display}}
                                </span>
                              {% endif %}
                            {% endif %}
                        </tr>
                    </tbody>
                </table>
            </div>
            <div class="panel-body">
                <h3>{% trans "My informations" %}</h3>
                {% if not applicant.has_complete_application %}
                  <div class="alert alert-warning" role="alert">
                    {% trans "You are missing some key information, you won't be able to validate your application !" %}
                  </div>
                {% endif %}
                <ul class="nav nav-stacked fa-ul">
                  {% for answer in applicant.get_ordered_answers %}
                    {% if applicant.edition == answer.applicant.edition %}
                      <li> <strong> {{answer.question}} </strong> </li>
                      <li>{{ answer }}</li>
                    {% endif %}
                  {% endfor %}
                </ul>

                {% if applicant.has_non_rejected_choices %}
                  <h3>{% trans "My applications" %}</h3>
                  <ol>
                    {% for wish in applicant.eventwish_set.all %}
                      {% if wish.status != 2 %}
                        <li>
                          {{ wish.event.short_description }}
                          <span class="badge {{ wish.status|status_badge }} pull-right">
                            {{ wish.get_status_display}}
                          </span>
                          {% if wish.status == 4 %}
                            <a class="pull-right" href="{% url 'gcc:confirm' wish=wish.pk%}" style="margin-right: 10px;">
                              <strong>
                                {% trans "Confirm my venue" %}
                              </strong>
                            </a>
                          {% endif %}
                        </li>
                      {% endif %}
                    {% endfor %}
                  </ol>
                {% endif %}

                {% if applicant.has_rejected_choices %}
                  <h3>{% trans "My rejected applications" %}</h3>
                  <ol>
                    {% for wish in applicant.eventwish_set.all %}
                      {% if wish.status == 2 %}
                        <li>
                          {{ wish.event.short_description }}
                          <span class="badge {{ wish.status|status_badge }} pull-right">
                            {{ wish.get_status_display}}
                          </span>
                        </li>
                      {% endif %}
                    {% endfor %}
                  </ol>
                {% endif %}

                <h3>{% trans "Status" %}</h3>
                <p>
                  {% if applicant.status == 0 %}
                    {% if applicant.edition.subscription_is_open %}
                      {% trans "Please validate your applications." %}
                    {% else %}
                      {% trans "Subscriptions are not opened yet for this year." %}
                    {% endif %}
                  {% elif applicant.status == 3 %}
                    {% trans "You will soon receive your assignation." %}
                  {% elif applicant.status == 4 %}
                    {% trans "You have been assigned to an event, please confirm your venue." %}
                  {% elif applicant.status == 5 %}
                    {% trans "Your venue has been confirmed!" %}
                  {% else %}
                    {% trans "Please wait while we review and update your application!" %}
                  {% endif %}
                </p>
              </div>
          </div>
    </div>
</div>
{% endblock %}

gccsite/gcc/templates/gcc/application/validation.html
{% extends "gcc/base.html" %}
{% load static %}
{% load i18n %}

{% block title %}{% trans "GCC! − Validation" %}{% endblock %}

{% block head %}
  <link rel="stylesheet" href="{% static 'vendor/bootstrap/dist/css/bootstrap.min.css' %}" />
{% endblock %}

{% block content %}
  {% if not applicant.has_complete_application %}
  <div class="alert alert-warning" role="alert">
    {% trans "You are missing some key information, you won't be able to validate your application !" %}
  </div>
  {% endif%}
  <center><h2>{% trans "Be careful after this you won't be able to change your answers or event wishes." %}</h2></center>
  <form method="post">
    {% csrf_token %}
    <center><button class="btn btn-default btn-lg" type="submit"><i class="fa fa-save"></i> {% trans "Validate application" %}</button></center>
  </form>
{% endblock %}

gccsite/gcc/templates/gcc/application/wishes.html
{% extends "gcc/base.html" %}
{% load bootstrap %}
{% load static %}
{% load i18n %}

{% block title %}{% trans "GCC! − Application" %}{% endblock %}

{% block head %}
<link rel="stylesheet" href="{% static " gcc/css/form.css"%}">
<link rel="stylesheet" href="{% static 'vendor/bootstrap/dist/css/bootstrap.min.css' %}" />
{% endblock %}

{% block content %}
<div class="container">
<h2>{% trans "Choose my location wishes" %}</h2>
  <form method="post" class="form-horizontal">
    {% csrf_token %}
    {{ form|bootstrap_horizontal:'col-md-2' }}
    <input class="btn btn-primary btn-lg btn-block" type="submit" value="{% trans "Confirm my application" %}">
  </form>
</div>

<h2>{% trans "Available centers" %}</h2>
<div class="container">
  <div class="row">
    {% for event in events %}
      <div class="col-md-6">
        <a href="//prologin.org/center"><h3>{{ event.center.name }}</h3></a>
        <p>
          {% blocktrans with start=event.event_start|date:"DATE_FORMAT" end=event.event_end|date:"DATE_FORMAT" %}
            From {{start}} to {{end}}
          {% endblocktrans %}
          <br />
          {{event.center.address}}, {{event.center.postal_code}} {{event.center.city}}<br />
          {% blocktrans with signup_end=event.signup_end|date:"DATE_FORMAT" %}Inscription close the {{signup_end}} {% endblocktrans %}
        </p>
      </div>
    {% endfor %}
  </div>
</div>
{% endblock %}